; ==========================================
; ==        A Modern Doc Check !!!        ==
; == The Words Are In The File MANUAL.TXT ==
; ==  Written In October 1993 By Z-N0TE   ==
; ==========================================
;
        
; ========= MAIN PROGRAM BLOCK ===========================================

START:  CALL    CLR_SCR
        CALL    GET_RND
        CALL    PROTECT
        
        MOV     DX,OFFSET CORRECT       ; Yep
        CALL    PRNT                    ; Print Ok message
        CALL    EXIT
;=========================================================================

PROTECT:CMP     DL,20                   ; If under 20/100th of a sec jump
        JL      QUES1                   ; Jump

        CMP     DL,40                   ; If under 40/100th of a sec jump
        JL      QUES2                   ; Jump

        CMP     DL,60                   ; If under 60/100th of a sec jump
        JL      QUES3                   ; Jump

        CMP     DL,80                   ; If under 80/100th of a sec jump
        JL      QUES4                   ; Jump
        
QUES5:  MOV     B [LINE_],'7'           ; Set up line number
        MOV     B [WORD_],'7'           ; Set up word number
        MOV     AX,W [ANS5]             ; Move real answer into ANSWER
        MOV     B [ANSWER],AX           ; ...
        JMP     SHORT MAIN              ; Jump to main code

QUES1:  MOV     B [LINE_],'1'           ; Set up line number
        MOV     B [WORD_],'5'           ; Set up word number
        MOV     AX,W [ANS1]             ; Move real answer into ANSWER
        MOV     B [ANSWER],AX           ; ...
        JMP     SHORT MAIN              ; Jump to main code

QUES2:  MOV     B [LINE_],'4'           ; Set up line number
        MOV     B [WORD_],'1'           ; Set up word number
        MOV     AX,W [ANS2]             ; Move real answer into ANSWER
        MOV     B [ANSWER],AX           ; ...
        JMP     SHORT MAIN              ; Jump to main code

QUES3:  MOV     B [LINE_],'5'           ; Set up line number
        MOV     B [WORD_],'6'           ; Set up word number
        MOV     AX,W [ANS3]             ; Move real answer into ANSWER
        MOV     B [ANSWER],AX           ; ...
        JMP     SHORT MAIN              ; Jump to main code

QUES4:  MOV     B [LINE_],'6'           ; Set up line number
        MOV     B [WORD_],'4'           ; Set up word number
        MOV     AX,W [ANS4]             ; Move real answer into ANSWER
        MOV     B [ANSWER],AX           ; ...

MAIN:   MOV     DX,OFFSET MESS1         ; Print "Enter word "
        CALL    PRNT                    ; Do it

        MOV     DX,OFFSET IN1           ; Get word
        CALL    GETIN                   ; Do it

        CALL    DOCCHK                  ; Call the check
        OR      AX,AX                   ; Is answer ok
        JNZ     FINE                    ; Yep

        MOV     DX,OFFSET WRONG         ; Nope
        CALL    PRNT                    ; Print buggered message
        INT     20h                     ; DOS

FINE:   RET                             ; Return to main rouine

PRNT:   MOV     AH,09h                  ; Print String Proc
        INT     21h                     ; Do it
        RET                             ; Return

GETIN:  MOV     AH,0Ah                  ; Get Char Input Proc
        INT     21h                     ; Do it
        RET                             ; Return

DOCCHK: XOR     BX,BX                   ; Clear BX
        MOV     SI,OFFSET INP1          ; Set SI to input text
        XOR     CH,CH                   ; Clear CH
        MOV     CL,B [NUM1]             ; How many chars typed
        SHR     CX,1                    ; Half it
HERE:   LODSW                           ; Load single WORD
        AND     AX,05F5Fh               ; Turn to uppercase
        XOR     BX,AX                   ; Make a checksum in BX
        LOOP    HERE                    ; Loop
        CMP     BX,W [ANSWER]           ; Check real answer with input
        MOV     AX,0001h                ; Set AX=1
        JZ      OK                      ; If ok jump
        XOR     AX,AX                   ; Set AX=0
OK:     RET                             ; Return to calling routine

CLR_SCR:MOV     AX,0003h                ; Screen Clear
        INT     10h                     ; ...
        RET
        
GET_RND:MOV     AH,2Ch                  ; Get time (Random number)
        INT     21h                     ; Do it
        RET

EXIT:   MOV     AH,4Ch
        INT     21h

MESS1:  DB      0D,0A,0D,0A,0D,0A,0D,0A,0D,0A,0D,0A
        DB      0D,0A,0D,0A,0D,0A,0D,0A,09,09,09
        DB      'Enter word ' 
 WORD_: DB      ' '
        DB      ' , on line '
 LINE_: DB      ' ' 
        DB      ' : $'

CORRECT:DB      0D,0A,0D,0A,09,09,09
        DB      'Correct!',0D,0A,'$'
WRONG:  DB      0D,0A,0D,0A,09,09,09
        DB      'Wrong!',0D,0A,'$'

IN1:    DB      0Dh
NUM1:   DB      00h
INP1:   DB      0Bh DUP(00)

ANSWER: DW      0000h

ANS1:   DW      0617h ; Checksums for words 
ANS2:   DW      180Dh
ANS3:   DW      0103h
ANS4:   DW      110Ch
ANS5:   DW      505Ah
